/*WBL 25 Nov 2025 example taken from
  https://github.com/rapidsai/cuspatial/tree/branch-24.12/cpp/cuproj#example

Modifications:
WBL  9 Jan 2025 Revert r1.3 then place in main() https://github.com/rapidsai/cuspatial/issues/1500#issuecomment-2578912917
WBL 17 Dec 2024 replace with https://github.com/rapidsai/cuspatial/tree/branch-25.02/cpp/cuproj#example

*/
#include <cuproj/projection_factories.cuh>
#include <cuproj/vec_2d.hpp>

int main(int argc, char* argv[]){
using T = float;

// Make a projection to convert WGS84 (lat, lon) coordinates to UTM zone 56S (x, y) coordinates
auto proj = cuproj::make_projection<cuproj::vec_2d<T>>("EPSG:4326", "EPSG:32756");

cuproj::vec_2d<T> sydney{-33.858700, 151.214000};  // Sydney, NSW, Australia
thrust::device_vector<cuproj::vec_2d<T>> d_in{1, sydney};
thrust::device_vector<cuproj::vec_2d<T>> d_out(d_in.size());

// Convert the coordinates. Works the same with a vector of many coordinates.
proj.transform(d_in.begin(), d_in.end(), d_out.begin(), cuproj::direction::FORWARD);

return 0;
}
